import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type AuctioneerCancelInstructionArgs = {
    buyerPrice: beet.bignum;
    tokenSize: beet.bignum;
};
export declare type AuctioneerCancelInstructionAccounts = {
    wallet: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    tokenMint: web3.PublicKey;
    authority: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    tradeState: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
};
export declare function createAuctioneerCancelInstruction(accounts: AuctioneerCancelInstructionAccounts, args: AuctioneerCancelInstructionArgs): web3.TransactionInstruction;
