import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type AuctioneerDepositInstructionArgs = {
    escrowPaymentBump: number;
    amount: beet.bignum;
};
export declare type AuctioneerDepositInstructionAccounts = {
    wallet: web3.PublicKey;
    paymentAccount: web3.PublicKey;
    transferAuthority: web3.PublicKey;
    escrowPaymentAccount: web3.PublicKey;
    treasuryMint: web3.PublicKey;
    authority: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
};
export declare function createAuctioneerDepositInstruction(accounts: AuctioneerDepositInstructionAccounts, args: AuctioneerDepositInstructionArgs): web3.TransactionInstruction;
