import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type AuctioneerSellInstructionArgs = {
    tradeStateBump: number;
    freeTradeStateBump: number;
    programAsSignerBump: number;
    tokenSize: beet.bignum;
};
export declare type AuctioneerSellInstructionAccounts = {
    wallet: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    metadata: web3.PublicKey;
    authority: web3.PublicKey;
    auctioneerAuthority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    sellerTradeState: web3.PublicKey;
    freeSellerTradeState: web3.PublicKey;
    ahAuctioneerPda: web3.PublicKey;
    programAsSigner: web3.PublicKey;
};
export declare function createAuctioneerSellInstruction(accounts: AuctioneerSellInstructionAccounts, args: AuctioneerSellInstructionArgs): web3.TransactionInstruction;
