import * as web3 from '@solana/web3.js';
export declare type CreateAuctionHouseInstructionArgs = {
    bump: number;
    feePayerBump: number;
    treasuryBump: number;
    sellerFeeBasisPoints: number;
    requiresSignOff: boolean;
    canChangeSalePrice: boolean;
};
export declare type CreateAuctionHouseInstructionAccounts = {
    treasuryMint: web3.PublicKey;
    payer: web3.PublicKey;
    authority: web3.PublicKey;
    feeWithdrawalDestination: web3.PublicKey;
    treasuryWithdrawalDestination: web3.PublicKey;
    treasuryWithdrawalDestinationOwner: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    auctionHouseTreasury: web3.PublicKey;
};
export declare function createCreateAuctionHouseInstruction(accounts: CreateAuctionHouseInstructionAccounts, args: CreateAuctionHouseInstructionArgs): web3.TransactionInstruction;
