import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type DepositInstructionArgs = {
    escrowPaymentBump: number;
    amount: beet.bignum;
};
export declare type DepositInstructionAccounts = {
    wallet: web3.PublicKey;
    paymentAccount: web3.PublicKey;
    transferAuthority: web3.PublicKey;
    escrowPaymentAccount: web3.PublicKey;
    treasuryMint: web3.PublicKey;
    authority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
};
export declare function createDepositInstruction(accounts: DepositInstructionAccounts, args: DepositInstructionArgs): web3.TransactionInstruction;
