import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type SellInstructionArgs = {
    tradeStateBump: number;
    freeTradeStateBump: number;
    programAsSignerBump: number;
    buyerPrice: beet.bignum;
    tokenSize: beet.bignum;
};
export declare type SellInstructionAccounts = {
    wallet: web3.PublicKey;
    tokenAccount: web3.PublicKey;
    metadata: web3.PublicKey;
    authority: web3.PublicKey;
    auctionHouse: web3.PublicKey;
    auctionHouseFeeAccount: web3.PublicKey;
    sellerTradeState: web3.PublicKey;
    freeSellerTradeState: web3.PublicKey;
    programAsSigner: web3.PublicKey;
};
export declare function createSellInstruction(accounts: SellInstructionAccounts, args: SellInstructionArgs): web3.TransactionInstruction;
